Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | Friends | List of all members
CollisionSolid Class Referenceabstract

The abstract base class for all things that can collide with other things in the world, and all the things they can collide with (except geometry). More...

`#include "collisionSolid.h"`

Inheritance diagram for CollisionSolid:

## Public Member Functions
| CollisionSolid (const CollisionSolid &copy)
void | clear_effective_normal ()
| Removes the normal previously set by set_effective_normal().
| CPT (BoundingVolume) get_bounds() const
virtual TypeHandle | force_init_type ()
virtual LPoint3 | get_collision_origin () const =0
const LVector3 & | get_effective_normal () const
| Returns the normal that was set by set_effective_normal().
bool | get_respect_effective_normal () const
virtual PStatCollector & | get_test_pcollector ()
| Returns a PStatCollector that is used to count the number of intersection tests made against a solid of this type in a given frame.
virtual TypeHandle | get_type () const
virtual PStatCollector & | get_volume_pcollector ()
| Returns a PStatCollector that is used to count the number of bounding volume tests made against a solid of this type in a given frame.
bool | has_effective_normal () const
| Returns true if a special normal was set by set_effective_normal(), false otherwise.
bool | is_tangible () const
virtual CollisionSolid * | make_copy ()=0
virtual void | output (std::ostream &out) const
virtual | PT (CollisionEntry) test_intersection(const CollisionEntry &entry) const
virtual | PT (PandaNode) get_viz(const CullTraverser *trav
void | set_bounds (const BoundingVolume &bounding_volume)
void | set_effective_normal (const LVector3 &effective_normal)
| Records a false normal for this CollisionSolid that will be reported by the collision system with all collisions into it, instead of its actual normal.
void | set_respect_effective_normal (bool respect_effective_normal)
void | set_tangible (bool tangible)
virtual void | write (std::ostream &out, int indent_level=0) const
virtual void | write_datagram (BamWriter *manager, Datagram &me)
| Function to write the important information in the particular object to a Datagram.
virtual void | xform (const LMatrix4 &mat)
| Transforms the solid by the indicated matrix.
Public Member Functions inherited from CopyOnWriteObject
| CopyOnWriteObject (const CopyOnWriteObject &copy)
void | operator= (const CopyOnWriteObject &copy)
Public Member Functions inherited from CachedTypedWritableReferenceCount
void | cache_ref () const
| Explicitly increments the cache reference count and the normal reference count simultaneously.
void | cache_ref_only () const
| Decrements the cache reference count without affecting the normal reference count.
bool | cache_unref () const
| Explicitly decrements the cache reference count and the normal reference count simultaneously.
int | get_cache_ref_count () const
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from CopyOnWriteObject
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from CachedTypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Public Attributes
virtual const CullTraverserData bool bounds_only | const
virtual const CullTraverserData & | data
| get_bounds
| Returns the solid's bounding volume.
| get_collision_origin
| get_respect_effective_normal
| See set_respect_effective_normal().
| is_tangible
| Returns whether the solid is considered 'tangible' or not.
| set_bounds
| Returns the solid's bounding volume.
| set_respect_effective_normal
| This is only meaningful for CollisionSolids that will be added to a traverser as colliders.
| set_tangible
| Sets the current state of the 'tangible' flag.
Public Attributes inherited from CachedTypedWritableReferenceCount
| get_cache_ref_count
| Returns the current reference count.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Friends
class | CollisionBox
class | CollisionCapsule
class | CollisionHandlerFluidPusher
class | CollisionLine
class | CollisionParabola
class | CollisionRay
class | CollisionSegment
class | CollisionSphere

## Additional Inherited Members
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

The abstract base class for all things that can collide with other things in the world, and all the things they can collide with (except geometry).

This class and its derivatives really work very similarly to the way BoundingVolume and all of its derivatives work. There's a different subclass for each basic shape of solid, and double-dispatch function calls handle the subset of the N*N intersection tests that we care about.

Definition at line 45 of file collisionSolid.h.

## Constructor & Destructor Documentation

## ◆ CollisionSolid() [1/2]

CollisionSolid::CollisionSolid | ( |  | ) |

Definition at line 45 of file collisionSolid.cxx.

## ◆ CollisionSolid() [2/2]

CollisionSolid::CollisionSolid | ( | const CollisionSolid & | copy | ) |

Definition at line 53 of file collisionSolid.cxx.

## ◆ ~CollisionSolid()

CollisionSolid::~CollisionSolid | ( |  | ) |
| virtual

Definition at line 67 of file collisionSolid.cxx.

## Member Function Documentation

## ◆ clear_effective_normal()

void CollisionSolid::clear_effective_normal | ( |  | ) |
| inline

Removes the normal previously set by set_effective_normal().

Definition at line 60 of file collisionSolid.I.

## ◆ force_init_type()

virtual TypeHandle CollisionSolid::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from CopyOnWriteObject.

Definition at line 171 of file collisionSolid.h.

## ◆ get_class_type()

static TypeHandle CollisionSolid::get_class_type | ( |  | ) |
| inline static

Definition at line 160 of file collisionSolid.h.

## ◆ get_collision_origin()

virtual LPoint3 CollisionSolid::get_collision_origin | ( |  | ) | const
| pure virtual

Implemented in CollisionBox, CollisionCapsule, CollisionFloorMesh, CollisionParabola, CollisionPlane, CollisionPolygon, CollisionRay, CollisionSegment, and CollisionSphere.

## ◆ get_effective_normal()

const LVector3 & CollisionSolid::get_effective_normal | ( |  | ) | const
| inline

Returns the normal that was set by set_effective_normal().

It is an error to call this unless has_effective_normal() returns true.

Definition at line 80 of file collisionSolid.I.

## ◆ get_test_pcollector()

PStatCollector & CollisionSolid::get_test_pcollector | ( |  | ) |
| virtual

Returns a PStatCollector that is used to count the number of intersection tests made against a solid of this type in a given frame.

Reimplemented in CollisionBox, CollisionCapsule, CollisionFloorMesh, CollisionGeom, CollisionInvSphere, CollisionParabola, CollisionPlane, CollisionPolygon, and CollisionSphere.

Definition at line 168 of file collisionSolid.cxx.

## ◆ get_type()

virtual TypeHandle CollisionSolid::get_type | ( |  | ) | const
| inline virtual

Reimplemented from CopyOnWriteObject.

Definition at line 168 of file collisionSolid.h.

## ◆ get_volume_pcollector()

PStatCollector & CollisionSolid::get_volume_pcollector | ( |  | ) |
| virtual

Returns a PStatCollector that is used to count the number of bounding volume tests made against a solid of this type in a given frame.

Reimplemented in CollisionBox, CollisionCapsule, CollisionFloorMesh, CollisionGeom, CollisionInvSphere, CollisionParabola, CollisionPlane, CollisionPolygon, and CollisionSphere.

Definition at line 159 of file collisionSolid.cxx.

## ◆ has_effective_normal()

bool CollisionSolid::has_effective_normal | ( |  | ) | const
| inline

Returns true if a special normal was set by set_effective_normal(), false otherwise.

Definition at line 70 of file collisionSolid.I.

## ◆ init_type()

static void CollisionSolid::init_type | ( |  | ) |
| inline static

Definition at line 163 of file collisionSolid.h.

## ◆ output()

void CollisionSolid::output | ( | std::ostream & | out | ) | const
| virtual

Definition at line 176 of file collisionSolid.cxx.

## ◆ set_effective_normal()

void CollisionSolid::set_effective_normal | ( | const LVector3 & | effective_normal | ) |
| inline

Records a false normal for this CollisionSolid that will be reported by the collision system with all collisions into it, instead of its actual normal.

This is useful as a workaround for the problem of an avatar wanting to stand on a sloping ground; by storing a false normal, the ground appears to be perfectly level, and the avatar does not tend to slide down it.

Definition at line 50 of file collisionSolid.I.

## ◆ write()

void CollisionSolid::write | ( | std::ostream & | out,
|  | int | indent_level = 0 ) const
| virtual

Definition at line 184 of file collisionSolid.cxx.

## ◆ write_datagram()

void CollisionSolid::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | me )
| virtual

Function to write the important information in the particular object to a Datagram.

Reimplemented from TypedWritable.

Reimplemented in CollisionBox, CollisionCapsule, CollisionFloorMesh, CollisionInvSphere, CollisionLine, CollisionParabola, CollisionPlane, CollisionPolygon, CollisionRay, CollisionSegment, and CollisionSphere.

Definition at line 344 of file collisionSolid.cxx.

References Datagram::add_uint8().

Referenced by CollisionBox::write_datagram(), CollisionCapsule::write_datagram(), CollisionFloorMesh::write_datagram(), CollisionParabola::write_datagram(), CollisionPlane::write_datagram(), CollisionRay::write_datagram(), CollisionSegment::write_datagram(), and CollisionSphere::write_datagram().

## ◆ xform()

void CollisionSolid::xform | ( | const LMatrix4 & | mat | ) |
| virtual

Transforms the solid by the indicated matrix.

Reimplemented in CollisionBox, CollisionCapsule, CollisionFloorMesh, CollisionParabola, CollisionPlane, CollisionPolygon, CollisionRay, CollisionSegment, and CollisionSphere.

Definition at line 117 of file collisionSolid.cxx.

Referenced by CollisionCapsule::xform(), CollisionFloorMesh::xform(), CollisionPlane::xform(), CollisionPolygon::xform(), CollisionRay::xform(), and CollisionSegment::xform().

## Friends And Related Symbol Documentation

## ◆ CollisionBox

friend class CollisionBox
| friend

Definition at line 183 of file collisionSolid.h.

## ◆ CollisionCapsule

friend class CollisionCapsule
| friend

Definition at line 180 of file collisionSolid.h.

## ◆ CollisionHandlerFluidPusher

friend class CollisionHandlerFluidPusher
| friend

Definition at line 182 of file collisionSolid.h.

## ◆ CollisionLine

friend class CollisionLine
| friend

Definition at line 177 of file collisionSolid.h.

## ◆ CollisionParabola

friend class CollisionParabola
| friend

Definition at line 181 of file collisionSolid.h.

## ◆ CollisionRay

friend class CollisionRay
| friend

Definition at line 178 of file collisionSolid.h.

## ◆ CollisionSegment

friend class CollisionSegment
| friend

Definition at line 179 of file collisionSolid.h.

## ◆ CollisionSphere

friend class CollisionSphere
| friend

Definition at line 176 of file collisionSolid.h.

## Member Data Documentation

## ◆ const

virtual const CullTraverserData bool bounds_only CollisionSolid::const

Definition at line 86 of file collisionSolid.h.

## ◆ data

virtual const CullTraverserData& CollisionSolid::data

Definition at line 85 of file collisionSolid.h.

## ◆ get_bounds

ConstPointerTo< BoundingVolume > CollisionSolid::get_bounds

Returns the solid's bounding volume.

Definition at line 76 of file collisionSolid.h.

Referenced by CollisionLevelStateBase::prepare_collider().

## ◆ get_collision_origin

CollisionSolid::get_collision_origin

Definition at line 57 of file collisionSolid.h.

## ◆ get_respect_effective_normal

bool CollisionSolid::get_respect_effective_normal
| inline

See set_respect_effective_normal().

Definition at line 72 of file collisionSolid.h.

## ◆ is_tangible

bool CollisionSolid::is_tangible
| inline

Returns whether the solid is considered 'tangible' or not.

An intangible solid has no effect in a CollisionHandlerPusher (except to throw an event); it's useful for defining 'trigger' planes and spheres, that cause an effect when passed through.

Definition at line 61 of file collisionSolid.h.

## ◆ set_bounds

void CollisionSolid::set_bounds

Returns the solid's bounding volume.

Definition at line 76 of file collisionSolid.h.

## ◆ set_respect_effective_normal

void CollisionSolid::set_respect_effective_normal
| inline

This is only meaningful for CollisionSolids that will be added to a traverser as colliders.

It is normally true, but if set false, it means that this particular solid does not care about the "effective" normal of other solids it meets, but rather always uses the true normal.

Definition at line 72 of file collisionSolid.h.

## ◆ set_tangible

void CollisionSolid::set_tangible
| inline

Sets the current state of the 'tangible' flag.

Set this true to make the solid tangible, so that a CollisionHandlerPusher will not allow another object to intersect it, or false to make it intangible, so that a CollisionHandlerPusher will ignore it except to throw an event.

Definition at line 61 of file collisionSolid.h.

The documentation for this class was generated from the following files:

- panda/src/collide/collisionSolid.h
- panda/src/collide/collisionSolid.cxx
- panda/src/collide/collisionSolid.I